<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>array-methods-prac</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<h1 id="quick-javascript-array-functions-practice">Quick JavaScript Array Functions Practice</h1>
<p>Want to learn how to use JavaScript array functions like map, reduce, filter, etc? Use this worksheet and the corresponding videos to figure out how!</p>
<h2 id="sample-data">Sample Data</h2>
<p>Here’s a sample piece of Star Wars data from the <a href="https://swapi.dev/">Star Wars API</a>.</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">const</span> characters <span class="op">=</span> [</a>
<a class="sourceLine" id="cb1-2" title="2">    <span class="op">{</span></a>
<a class="sourceLine" id="cb1-3" title="3">        <span class="dt">name</span><span class="op">:</span> <span class="st">&#39;Luke Skywalker&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-4" title="4">        <span class="dt">height</span><span class="op">:</span> <span class="st">&#39;172&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-5" title="5">        <span class="dt">mass</span><span class="op">:</span> <span class="st">&#39;77&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-6" title="6">        <span class="dt">eye_color</span><span class="op">:</span> <span class="st">&#39;blue&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-7" title="7">        <span class="dt">gender</span><span class="op">:</span> <span class="st">&#39;male&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-8" title="8">    <span class="op">},</span></a>
<a class="sourceLine" id="cb1-9" title="9">    <span class="op">{</span></a>
<a class="sourceLine" id="cb1-10" title="10">        <span class="dt">name</span><span class="op">:</span> <span class="st">&#39;Darth Vader&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-11" title="11">        <span class="dt">height</span><span class="op">:</span> <span class="st">&#39;202&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-12" title="12">        <span class="dt">mass</span><span class="op">:</span> <span class="st">&#39;136&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-13" title="13">        <span class="dt">eye_color</span><span class="op">:</span> <span class="st">&#39;yellow&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-14" title="14">        <span class="dt">gender</span><span class="op">:</span> <span class="st">&#39;male&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-15" title="15">    <span class="op">},</span></a>
<a class="sourceLine" id="cb1-16" title="16">    <span class="op">{</span></a>
<a class="sourceLine" id="cb1-17" title="17">        <span class="dt">name</span><span class="op">:</span> <span class="st">&#39;Leia Organa&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-18" title="18">        <span class="dt">height</span><span class="op">:</span> <span class="st">&#39;150&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-19" title="19">        <span class="dt">mass</span><span class="op">:</span> <span class="st">&#39;49&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-20" title="20">        <span class="dt">eye_color</span><span class="op">:</span> <span class="st">&#39;brown&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-21" title="21">        <span class="dt">gender</span><span class="op">:</span> <span class="st">&#39;female&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-22" title="22">    <span class="op">},</span></a>
<a class="sourceLine" id="cb1-23" title="23">    <span class="op">{</span></a>
<a class="sourceLine" id="cb1-24" title="24">        <span class="dt">name</span><span class="op">:</span> <span class="st">&#39;Anakin Skywalker&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-25" title="25">        <span class="dt">height</span><span class="op">:</span> <span class="st">&#39;188&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-26" title="26">        <span class="dt">mass</span><span class="op">:</span> <span class="st">&#39;84&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-27" title="27">        <span class="dt">eye_color</span><span class="op">:</span> <span class="st">&#39;blue&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-28" title="28">        <span class="dt">gender</span><span class="op">:</span> <span class="st">&#39;male&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-29" title="29">    <span class="op">},</span></a>
<a class="sourceLine" id="cb1-30" title="30">]<span class="op">;</span></a></code></pre></div>
<h2 id="map">MAP</h2>
<ol type="1">
<li>Get an array of all names</li>
<li>Get an array of all heights</li>
<li>Get an array of objects with just name and height properties</li>
<li>Get an array of all first names</li>
</ol>
<h2 id="reduce">REDUCE</h2>
<ol type="1">
<li>Get the total mass of all characters</li>
<li>Get the total height of all characters</li>
<li>Get the total number of characters in all the character names</li>
<li>Get the total number of characters by eye color (hint. a map of eye color to count)</li>
</ol>
<h2 id="filter">FILTER</h2>
<ol type="1">
<li>Get characters with mass greater than 100</li>
<li>Get characters with height less than 200</li>
<li>Get all male characters</li>
<li>Get all female characters</li>
</ol>
<h2 id="sort">SORT</h2>
<ol type="1">
<li>Sort by name</li>
<li>Sort by mass</li>
<li>Sort by height</li>
<li>Sort by gender</li>
</ol>
<h2 id="every">EVERY</h2>
<ol type="1">
<li>Does every character have blue eyes?</li>
<li>Does every character have mass more than 40?</li>
<li>Is every character shorter than 200?</li>
<li>Is every character male?</li>
</ol>
<h2 id="some">SOME</h2>
<ol type="1">
<li>Is there at least one male character?</li>
<li>Is there at least one character with blue eyes?</li>
<li>Is there at least one character taller than 200?</li>
<li>Is there at least one character that has mass less than 50?</li>
</ol>
</body>
</html>
